## dde-grand-search 6.0.9.2

=== CMakeLists.txt ===
# 定义需要的cmake版本
cmake_minimum_required(VERSION 3.10)
add_compile_definitions(APP_VERSION="${VERSION}")

# 显示编译过程
set(CMAKE_VERBOSE_MAKEFILE ON)

# 设置工程名字
project(dde-grand-search)

# Install settings
include(GNUInstallDirs)
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DQT_DEBUG")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wl,--as-need")

#安全加固
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-all -z now")
if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "mips")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -z noexecstack -z relro")
endif()

# Find Qt version
if (NOT DEFINED QT_VERSION_MAJOR)
    set(QT_VERSION_MAJOR 6)
endif()
if (QT_VERSION_MAJOR MATCHES 6)
    set(DTK_VERSION_MAJOR 6)
else()
    set(DTK_VERSION_MAJOR "")
endif()
message("   >>> Found Qt version: ${QT_VERSION_MAJOR}")
message("   >>> Build with DTK: ${DTK_VERSION_MAJOR}")

set(QT_NS Qt${QT_VERSION_MAJOR})
set(DTK_NS Dtk${DTK_VERSION_MAJOR})

#tar -czvf antlr4.tar.gz ./antlr4
if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/antlr4")
    message("find antlr4")
else()
    message("decompression antlr4")
    execute_process(
        COMMAND tar -xzvf antlr4.tar.gz
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty
        RESULT_VARIABLE ANTLR_UNZIP_RESULT
    )

    if (NOT ANTLR_UNZIP_RESULT EQUAL "0")
        message(FATAL_ERROR "tar antlr4.tar.gz failed: ${ANTLR_UNZIP_RESULT}")
    endif()
endif()

configure_file(${CMAKE_SOURCE_DIR}/src/environments.h.in ${CMAKE_SOURCE_DIR}/src/environments.h @ONLY)

include_directories(${CMAKE_SOURCE_DIR}/src)
include_directories(${CMAKE_SOURCE_DIR}/3rdparty)
include_directories(${CMAKE_SOURCE_DIR}/src/tools)

# 平台库目录
set(LIB_PLATFORM_DIR "${CMAKE_INSTALL_PREFIX}/lib/${CMAKE_LIBRARY_ARCHITECTURE}")
message("LIB_PLATFORM_DIR: ${LIB_PLATFORM_DIR}")

#全局文件
FILE(GLOB GLOBAL_SRC "./src/global/*.h" "./src/global/*.cpp" "./src/global/accessibility/*.h")

# 国际化
if (NOT (${CMAKE_BUILD_TYPE} MATCHES "Debug"))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Ofast")

    # generate qm
    execute_process(COMMAND bash "translate_generation.sh"
                    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
endif ()

# 定义前端可执行程序名称
set(SEARCH_BIN_NAME dde-grand-search)

# 定义前端应用库目录
set(SEARCH_LIB_BASE_DIR "${LIB_PLATFORM_DIR}/${SEARCH_BIN_NAME}")

# 定义前端插件目录
set(SEARCH_PLUGIN_BASE_DIR "${SEARCH_LIB_BASE_DIR}/plugins")

# 定义前端预览插件目录
set(PLUGIN_PREVIEW_DIR "${SEARCH_PLUGIN_BASE_DIR}/preview")
add_definitions(-DPLUGIN_PREVIEW_DIR="${PLUGIN_PREVIEW_DIR}")

# 定义后端库名称
set(DAEMON_LIB_NAME libdde-grand-search-daemon)

# 定义后端可执行程序名称
set(DAEMON_BIN_NAME dde-grand-search-daemon)

# 定义后端应用库目录
set(DAEMON_LIB_BASE_DIR "${LIB_PLATFORM_DIR}/${DAEMON_BIN_NAME}")

# 定义后端插件目录
set(DAEMON_PLUGIN_DIR "${DAEMON_LIB_BASE_DIR}/plugins")

# 定义3rdparty目录
set(PROJECT_3RDPARTY_PATH "${CMAKE_SOURCE_DIR}/3rdparty")

# 定义后端扩展搜索插件目录
set(PLUGIN_SEARCHER_DIR "${DAEMON_PLUGIN_DIR}/searcher")
add_definitions(-DPLUGIN_SEARCHER_DIR="${PLUGIN_SEARCHER_DIR}")

# 获取系统版本
if (NOT DEFINED BUILD_OS_VERSION OR BUILD_OS_VERSION STREQUAL "")
    # 读取文件并提取Version值
    file(STRINGS "/etc/deepin-version" FILE_CONTENTS REGEX "^Version=")

    # 遍历文件内容，查找Version行
    foreach(LINE ${FILE_CONTENTS})
        # 检查是否是Version行
        if(LINE MATCHES "Version=([0-9]+)")
            # 提取版本号
            set(BUILD_OS_VERSION "${CMAKE_MATCH_1}")
        endif()
    endforeach()

    message("Get BUILD_OS_VERSION from deepin-version ${BUILD_OS_VERSION}")
else()
    message("catch BUILD_OS_VERSION ${BUILD_OS_VERSION}")
endif()

add_subdirectory(src/grand-search)
add_subdirectory(src/dde-grand-search-daemon)
add_subdirectory(src/grand-search-dock-plugin)
add_subdirectory(src/preview-plugin)
add_subdirectory(src/tools/semanticparser)
add_subdirectory(src/tools/luceneengine)
add_subdirectory(3rdparty/antlr4/antlr4-runtime)

if (${BUILD_OS_VERSION} GREATER_EQUAL "25")
    add_subdirectory(src/grand-search-shell-plugin)
endif()

=== src/dde-grand-search-daemon/CMakeLists.txt ===
# 定义需要的cmake版本
cmake_minimum_required(VERSION 3.10)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIE -pie")

# 设置名称
set(BIN_NAME ${DAEMON_BIN_NAME})

# 依赖包
find_package(PkgConfig REQUIRED)
find_package(${DTK_NS} COMPONENTS
    Gui
    Widget
REQUIRED)
find_package(${QT_NS} COMPONENTS
    Core
    Gui
    Widgets
    Concurrent
    DBus
REQUIRED)
find_package(deepin-qdbus-service REQUIRED)
find_package(dfm6-search REQUIRED)

add_definitions(-DSERVICE_CONFIG_DIR="${CMAKE_INSTALL_PREFIX}/share/deepin-service-manager/")

set(Qt_LIBS
    ${QT_NS}::Core
    ${QT_NS}::Gui
    ${QT_NS}::Widgets
    ${QT_NS}::DBus
    ${QT_NS}::Concurrent
)

set(DTK_LIBS
    ${DTK_NS}::Gui
    ${DTK_NS}::Widget
)

# 依赖库
set(LINK_LIBS
    ${Qt_LIBS}
    ${DTK_LIBS}
    ${deepin-qdbus-service_LIBRARIES}
    dfm6-search
)

# 源文件
set(DBUS
    dbusservice/grandsearchinterface_p.h
    dbusservice/grandsearchinterface.h
    dbusservice/grandsearchinterface.cpp
)

set(MAINCTRL
    maincontroller/maincontroller.h
    maincontroller/maincontroller_p.h
    maincontroller/maincontroller.cpp
    maincontroller/task/taskcommander.h
    maincontroller/task/taskcommander.cpp
    maincontroller/task/taskcommander_p.h
)

FILE(GLOB_RECURSE SEMANTIC_FILES
    "${CMAKE_CURRENT_SOURCE_DIR}/searcher/semantic/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/searcher/semantic/*.cpp"
    "${PROJECT_3RDPARTY_PATH}/antlr4/querylang/*.h"
    "${PROJECT_3RDPARTY_PATH}/antlr4/querylang/*.cpp"
)

set(SEARCHER
    searcher/searchergroup.h
    searcher/searchergroup_p.h
    searcher/searchergroup.cpp
    searcher/searcher.h
    searcher/searcher.cpp
    searcher/proxyworker.h
    searcher/proxyworker.cpp
    searcher/app/desktopappsearcher.h
    searcher/app/desktopappsearcher_p.h
    searcher/app/desktopappsearcher.cpp
    searcher/app/desktopappworker.h
    searcher/app/desktopappworker.cpp
    searcher/web/statictextechoer.h
    searcher/web/statictextechoer.cpp
    searcher/web/statictextworker.h
    searcher/web/statictextworker.cpp
    searcher/extend/extendsearcher.h
    searcher/extend/extendsearcher_p.h
    searcher/extend/extendsearcher.cpp
    searcher/extend/extendworker.h
    searcher/extend/extendworker.cpp
    searcher/file/filenamesearcher.h
    searcher/file/filenamesearcher.cpp
    searcher/file/filenameworker.h
    searcher/file/filenameworker.cpp
    searcher/file/filenameworker_p.h
    searcher/file/filesearchutils.h
    searcher/file/filesearchutils.cpp
)

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "x86_64")
    ADD_DEFINITIONS(-DENABLE_SEMANTIC)
    set(SEARCHER
        ${SEARCHER}
        ${SEMANTIC_FILES}
    )

    set(LINK_LIBS
        ${LINK_LIBS}
        semanticparser
        luceneengine
        antlr4_static
    )
endif()

# 手动生成xml描述文件
# qdbuscpp2xml -A grandsearchplugininterfacev1.h -o com.deepin.dde.grandsearch.searchplugin.xml
set(PLUGIN_ABSTRACT_IFS
    searchplugin/interface/abstract/grandsearchplugininterfacev1.h
)

# 插件通信接口
set(SEARCHPLUGIN_IFS
    searchplugin/interface/searchplugininterfacev1.h
    searchplugin/interface/searchplugininterfacev1.cpp
)

# 插件通信协议
set(SEARCHPLUGIN_PROT
    searchplugin/convertors/abstractconvertor.h
    searchplugin/convertors/abstractconvertor.cpp
    searchplugin/convertors/convertorv1_0.h
    searchplugin/convertors/convertorv1_0.cpp
)

set(SEARCHPLUGIN
    searchplugin/pluginmanager.h
    searchplugin/pluginmanager_p.h
    searchplugin/pluginmanager.cpp
    searchplugin/loader/pluginloader.h
    searchplugin/loader/pluginloader.cpp
    searchplugin/process/pluginprocess.h
    searchplugin/process/pluginprocess.cpp
    searchplugin/convertors/dataconvertor.h
    searchplugin/convertors/dataconvertor.cpp
    searchplugin/pluginliaison.h
    searchplugin/pluginliaison_p.h
    searchplugin/pluginliaison.cpp
    ${SEARCHPLUGIN_IFS}
    ${SEARCHPLUGIN_PROT}
)

set(GDCONFIGURATION
    configuration/configer.h
    configuration/configer_p.h
    configuration/configer.cpp
    configuration/preferenceitem.h
    configuration/userpreference.h
    configuration/userpreference.cpp
)

set(UTILS
    utils/searchpluginconf.h
    utils/searchplugininfo.h
    utils/searchpluginprotocol.h
    utils/specialtools.h
    utils/specialtools.cpp
    utils/chineseletterhelper.h
    utils/chineseletterhelper.cpp
)

set(SRCS
    main.cpp

    ${GLOBAL_SRC}
    ${UTILS}
    ${DBUS}
    ${MAINCTRL}
    ${SEARCHER}
    ${SEARCHPLUGIN}
    ${GDCONFIGURATION}
)

if (${QT_VERSION_MAJOR} EQUAL 5)
    qt5_add_resources(QRC_FILES utils/dict.qrc)
else()
    qt_add_resources(QRC_FILES utils/dict.qrc)
endif()

# 执行程序
add_executable(${BIN_NAME}
    ${SRCS} ${QRC_FILES}
)

target_include_directories(${BIN_NAME} PUBLIC
    ${CMAKE_SOURCE_DIR}/include
    ${GLIB_INCLUDE_DIRS}
    ${PCRE_INCLUDE_DIRS}
    ${deepin-qdbus-service_INCLUDE_DIR}
    ${PROJECT_3RDPARTY_PATH}/antlr4/querylang
    ${PROJECT_3RDPARTY_PATH}/antlr4/antlr4-runtime/runtime/src
)

target_link_libraries(${BIN_NAME} PRIVATE
    ${LINK_LIBS}
)

install(TARGETS ${BIN_NAME} DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES grand-search-daemon.json DESTINATION share/deepin-service-manager/other/)
install(FILES org.deepin.dde.GrandSearchDaemon.service DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/dbus-1/services)

# 扩展搜索插件目录
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/.readme DESTINATION ${PLUGIN_SEARCHER_DIR})

=== src/grand-search/CMakeLists.txt ===
# 定义需要的cmake版本
cmake_minimum_required(VERSION 3.10)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIE -pie")

# 定义可执行程序名称
set(BIN_NAME ${SEARCH_BIN_NAME})

# 集成测试标签
ADD_DEFINITIONS(-DENABLE_ACCESSIBILITY)

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "mips"
        OR ${CMAKE_SYSTEM_PROCESSOR} MATCHES "aarch64"
        OR ${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw"
        OR ${CMAKE_SYSTEM_PROCESSOR} MATCHES "loongarch64"
        )
    message("${CMAKE_SYSTEM_PROCESSOR} : disable ai search")
else()
    message("${CMAKE_SYSTEM_PROCESSOR} : enable ai search")
    ADD_DEFINITIONS(-DENABLE_AI_SEARCH)
endif()

# 依赖包
find_package(PkgConfig REQUIRED)
find_package(${DTK_NS} COMPONENTS
    Core
    Gui
    Widget
REQUIRED)
find_package(${QT_NS} COMPONENTS
    Core
    Gui
    Widgets
    Concurrent
    DBus
    Network
REQUIRED)

set(DBUSSRC
    # dbus接口
    ${PROJECT_3RDPARTY_PATH}/interfaces/daemongrandsearchinterface.h
    ${PROJECT_3RDPARTY_PATH}/interfaces/daemongrandsearchinterface.cpp
    # dbus服务
    ${PROJECT_3RDPARTY_PATH}/services/grandsearchserviceadaptor.h
    ${PROJECT_3RDPARTY_PATH}/services/grandsearchserviceadaptor.cpp
)

set(Qt_LIBS
    ${QT_NS}::Core
    ${QT_NS}::Gui
    ${QT_NS}::Widgets
    ${QT_NS}::DBus
    ${QT_NS}::Concurrent
    ${QT_NS}::Network
)
set(DTK_LIBS
    ${DTK_NS}::Core
    ${DTK_NS}::Gui
    ${DTK_NS}::Widget
)

# gio 打开功能需要依赖的库
pkg_check_modules(GIO_LIB REQUIRED
        gio-unix-2.0
        glib-2.0
)

# gui
set(GUISRC
    gui/mainwindow_p.h
    gui/mainwindow.h
    gui/mainwindow.cpp
    # 可见性/退出处理
    gui/handlevisibility/handlevisibility.h
    gui/handlevisibility/handlevisibility.cpp
    # 界面相关数据定义
    gui/datadefine.h
    # 入口界面
    gui/entrance/entrancewidget_p.h
    gui/entrance/entrancewidget.h
    gui/entrance/entrancewidget.cpp
    # 展示界面
    gui/exhibition/exhibitionwidget_p.h
    gui/exhibition/exhibitionwidget.h
    gui/exhibition/exhibitionwidget.cpp
    gui/exhibition/matchresult/matchwidget_p.h
    gui/exhibition/matchresult/matchwidget.h
    gui/exhibition/matchresult/matchwidget.cpp
    gui/exhibition/matchresult/groupwidget_p.h
    gui/exhibition/matchresult/groupwidget.h
    gui/exhibition/matchresult/groupwidget.cpp
    # listView
    gui/exhibition/matchresult/listview/grandsearchlistdelegate.h
    gui/exhibition/matchresult/listview/grandsearchlistdelegate.cpp
    gui/exhibition/matchresult/listview/grandsearchlistmodel.h
    gui/exhibition/matchresult/listview/grandsearchlistmodel.cpp
    gui/exhibition/matchresult/listview/grandsearchlistview.h
    gui/exhibition/matchresult/listview/grandsearchlistview.cpp
    # viewMore
    gui/exhibition/matchresult/viewmore/viewmorebutton.cpp
    gui/exhibition/matchresult/viewmore/viewmorebutton.h
    # preview
    gui/exhibition/preview/previewwidget.h
    gui/exhibition/preview/previewwidget.cpp
    gui/exhibition/preview/previewplugin.h
    gui/exhibition/preview/previewplugininterface.h
    gui/exhibition/preview/previewpluginmanager.h
    gui/exhibition/preview/previewpluginmanager.cpp
    gui/exhibition/preview/generalpreviewplugin_p.h
    gui/exhibition/preview/generalpreviewplugin.h
    gui/exhibition/preview/generalpreviewplugin.cpp
    gui/exhibition/preview/generalwidget/generaltoolbar.h
    gui/exhibition/preview/generalwidget/generaltoolbar.cpp
    gui/exhibition/preview/generalwidget/replicablelabel.h
    gui/exhibition/preview/generalwidget/replicablelabel.cpp
    gui/exhibition/preview/generalwidget/detailitem.h
    gui/exhibition/preview/generalwidget/detailitem.cpp
    gui/exhibition/preview/generalwidget/detailwidget.h
    gui/exhibition/preview/generalwidget/detailwidget.cpp
    gui/exhibition/preview/generalwidget/transbutton.h
    gui/exhibition/preview/generalwidget/transbutton.cpp
    gui/exhibition/preview/generalwidget/linkbutton.h
    gui/exhibition/preview/generalwidget/linkbutton.cpp
    gui/exhibition/preview/generalwidget/omitbutton.h
    gui/exhibition/preview/generalwidget/omitbutton.cpp
    gui/exhibition/preview/generalwidget/aitoolbar.h
    gui/exhibition/preview/generalwidget/aitoolbar.cpp
    gui/exhibition/preview/pluginproxy.h
    gui/exhibition/preview/pluginproxy.cpp
    gui/exhibition/preview/previewproxyinterface.h
    # setting
    gui/searchconfig/configwidget.cpp
    gui/searchconfig/configwidget.h
    gui/searchconfig/scopewidget.cpp
    gui/searchconfig/scopewidget.h
    gui/searchconfig/planwidget.cpp
    gui/searchconfig/planwidget.h
    gui/searchconfig/customwidget.cpp
    gui/searchconfig/customwidget.h
    gui/searchconfig/tailerwidget.cpp
    gui/searchconfig/tailerwidget.h
    gui/searchconfig/searchenginewidget.cpp
    gui/searchconfig/searchenginewidget.h
    gui/searchconfig/checkboxwidget/checkboxwidget.cpp
    gui/searchconfig/checkboxwidget/checkboxwidget.h
    gui/searchconfig/checkboxwidget/checkboxitem.cpp
    gui/searchconfig/checkboxwidget/checkboxitem.h
    gui/searchconfig/switchwidget/switchwidget.cpp
    gui/searchconfig/switchwidget/switchwidget.h
    gui/searchconfig/llmwidget/llmwidget.cpp
    gui/searchconfig/llmwidget/llmwidget.h
    gui/searchconfig/llmwidget/modelmanagebutton.cpp
    gui/searchconfig/llmwidget/modelmanagebutton.h
    gui/searchconfig/llmwidget/downloader.h
    gui/searchconfig/llmwidget/downloader.cpp
    gui/searchconfig/llmwidget/embeddingpluginwidget.cpp
    gui/searchconfig/llmwidget/embeddingpluginwidget.h
    gui/searchconfig/hyperlinklabel/hyperlinklabel.cpp
    gui/searchconfig/hyperlinklabel/hyperlinklabel.h
    gui/searchconfig/comboboxwidget/comboboxwidget.h
    gui/searchconfig/comboboxwidget/comboboxwidget.cpp
    gui/searchconfig/bestmatchwidget.cpp
    gui/searchconfig/bestmatchwidget.h
    gui/searchconfig/blacklistview/blacklistview.h
    gui/searchconfig/blacklistview/blacklistview.cpp
    gui/searchconfig/blacklistview/blacklistmodel.cpp
    gui/searchconfig/blacklistview/blacklistmodel.h
    gui/searchconfig/blacklistview/blacklistdelegate.cpp
    gui/searchconfig/blacklistview/blacklistdelegate.h
    gui/searchconfig/blacklistview/deletedialog.cpp
    gui/searchconfig/blacklistview/deletedialog.h
    gui/searchconfig/blacklistwidget.cpp
    gui/searchconfig/blacklistwidget.h
    gui/searchconfig/indexwidget.cpp
    gui/searchconfig/indexwidget.h
    gui/searchconfig/intelligentretrieval/intelligentretrievalwidget.h
    gui/searchconfig/intelligentretrieval/intelligentretrievalwidget.cpp
    gui/searchconfig/roundedbackground.h
    gui/searchconfig/roundedbackground.cpp
    gui/searchconfig/intelligentretrieval/detailcheckbox.cpp
    gui/searchconfig/intelligentretrieval/detailcheckbox.h
    gui/searchconfig/intelligentretrieval/autoindexstatus.cpp
    gui/searchconfig/intelligentretrieval/autoindexstatus.h
    gui/searchconfig/tipslabel.h
    gui/searchconfig/tipslabel.cpp
    )

# business
set(BUSINESSSRC
    # 查询控制
    business/query/querycontroller_p.h
    business/query/querycontroller.h
    business/query/querycontroller.cpp
    # 匹配结果控制
    business/matchresult/matchcontroller_p.h
    business/matchresult/matchcontroller.h
    business/matchresult/matchcontroller.cpp
    # 配置读写
    business/config/searchconfig.cpp
    business/config/searchconfig.h
    # 访问记录
    business/config/accessrecord/accessrecord.h
    business/config/accessrecord/accessrecord.cpp
    )

# contacts
set(CONTACTSSRC
    # dbus服务
    contacts/services/grandsearchservice_p.h
    contacts/services/grandsearchservice.h
    contacts/services/grandsearchservice.cpp
    )

# utils
set(UTILSSRC
    utils/utils.h
    utils/utils.cpp
    utils/previewpluginconf.h
    utils/filestatisticsthread.h
    utils/filestatisticsthread.cpp
    utils/report/basicpoint.h
    utils/report/basicpoint.cpp
    utils/report/committhread.h
    utils/report/committhread.cpp
    utils/report/eventlogutil.h
    utils/report/eventlogutil.cpp
    utils/report/aisearchpoint.h
    )

# 源文件
set(SRCS
    main.cpp
    ${GLOBAL_SRC}
    ${GUISRC}
    ${BUSINESSSRC}
    ${CONTACTSSRC}
    ${UTILSSRC}
    ${DBUSSRC}
)

# 指定资源文件
set(QRCS
    gui/searchconfig/resource.qrc
    gui/exhibition/preview/resource.qrc
    gui/exhibition/matchresult/resource.qrc
    )

add_executable(${BIN_NAME} ${SRCS} ${QRCS})

target_include_directories(${BIN_NAME} PUBLIC
    ${CMAKE_SOURCE_DIR}/include
    ${GIO_LIB_INCLUDE_DIRS}
)

target_link_libraries(${BIN_NAME} PRIVATE
    ${Qt_LIBS}
    ${DTK_LIBS}
    ${GIO_LIB_LIBRARIES}
)

set(SRCS_SETTING
    setting_main.cpp
    contacts/services/grandsearchsettingservice_p.h
    contacts/services/grandsearchsettingservice.h
    contacts/services/grandsearchsettingservice.cpp
    ${PROJECT_3RDPARTY_PATH}/services/grandsearchsettingserviceadaptor.h
    ${PROJECT_3RDPARTY_PATH}/services/grandsearchsettingserviceadaptor.cpp
)

add_executable(${BIN_NAME}-setting ${SRCS_SETTING})
target_link_libraries(${BIN_NAME}-setting PRIVATE
    ${Qt_LIBS}
    ${DTK_LIBS}
)

# Install settings
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

# bin
install(TARGETS ${BIN_NAME} DESTINATION bin)
install(TARGETS ${BIN_NAME}-setting DESTINATION bin)
# ts
install(DIRECTORY ${PROJECT_SOURCE_DIR}/translations
    DESTINATION share/${BIN_NAME}
    FILES_MATCHING PATTERN "*.qm")

# dbus
install(FILES contacts/services/com.deepin.dde.GrandSearch.service DESTINATION ${CMAKE_INSTALL_DATADIR}/dbus-1/services)
install(FILES contacts/services/com.deepin.dde.GrandSearch.xml DESTINATION ${CMAKE_INSTALL_DATADIR}/dbus-1/interfaces)

# setting
install(FILES contacts/services/com.deepin.dde.GrandSearchSetting.service DESTINATION ${CMAKE_INSTALL_DATADIR}/dbus-1/services)
install(FILES contacts/services/com.deepin.dde.GrandSearchSetting.xml DESTINATION ${CMAKE_INSTALL_DATADIR}/dbus-1/interfaces)

=== src/tools/luceneengine/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)

set(LIB_NAME luceneengine)

find_package(${QT_NS} COMPONENTS Gui REQUIRED)
find_package(PkgConfig REQUIRED)

pkg_check_modules(Lucene REQUIRED IMPORTED_TARGET liblucene++ liblucene++-contrib)

FILE(GLOB_RECURSE SRC_FILES
    "${CMAKE_CURRENT_SOURCE_DIR}/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
)

FILE(GLOB_RECURSE LUCENE_FILES
    "${PROJECT_3RDPARTY_PATH}/lucene/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/lucene/*.cpp"
)

add_library(${LIB_NAME} STATIC ${SRC_FILES} ${LUCENE_FILES})

target_include_directories(${LIB_NAME}
    PRIVATE
        ${CMAKE_CURRENT_BINARY_DIR}
)

target_link_libraries(
    ${LIB_NAME}
    ${QT_NS}::Gui
    PkgConfig::Lucene
)

=== debian/changelog ===
dde-grand-search (6.0.9.2) unstable; urgency=medium

  * Adapt to DFM search interface

 -- Liu Zhangjian <liuzhangjian@uniontech.com>  Fri, 09 May 2025 14:13:11 +0800

dde-grand-search (6.0.9.1) unstable; urgency=medium

  * test for new-file-search

 -- Zhang Sheng <zhangsheng@uniontech.com>  Tue, 22 Apr 2025 13:20:24 +0800

dde-grand-search (6.0.9) unstable; urgency=medium

  * New version 6.0.9

 -- Liu Zhangjian <liuzhangjian@uniontech.com>  Thu, 10 Apr 2025 20:14:55 +0800

dde-grand-search (6.0.8) unstable; urgency=medium

  * New version 6.0.8

 -- Liu Zhangjian <liuzhangjian@uniontech.com>  Thu, 10 Apr 2025 16:26:56 +0800

dde-grand-search (6.0.7) unstable; urgency=medium

  * fix: improve service availability check in FileNameSearcher

 -- Liu Zhangjian <liuzhangjian@uniontech.com>  Wed, 02 Apr 2025 15:56:32 +0800

dde-grand-search (6.0.6) unstable; urgency=medium

  * New version 6.0.6. 

 -- Wang Yu <wangyu@uniontch.com>  Thu, 27 Mar 2025 14:01:08 +0800

dde-grand-search (6.0.5) unstable; urgency=medium

  * New version 6.0.5. 

 -- Wang Yu <wangyu@uniontch.com>  Thu, 06 Mar 2025 20:33:23 +0800

dde-grand-search (6.0.4) unstable; urgency=medium

  * fix: improve plugin item opening with async dbus call(Bug: 305007)

 -- renbin <renbin@uniontech.com>  Thu, 27 Feb 2025 19:12:56 +0800

dde-grand-search (6.0.3) unstable; urgency=medium

  * New version 6.0.3

 -- Liu zheng <liuzheng@uniontech.com>  Fri, 14 Feb 2025 10:15:53 +0800

dde-grand-search (6.0.2) unstable; urgency=medium

  * New version 6.0.2

 -- Wang Yu <wangyu@uniontch.com>  Wed, 22 Jan 2025 10:40:39 +0800

dde-grand-search (6.0.1) unstable; urgency=medium

  * update dde-grand-search V25 6.0.1 baseline version

 -- zhangyu <zhangyub@uniontech.com>  Tues, 21 Jan 2025 15:05:50 +0800

dde-grand-search (6.0.0) unstable; urgency=medium

  * New version 6.0.0
  * support Qt6

 -- Wang Yu <wangyu@uniontch.com>  Mon, 20 Jan 2025 13:49:28 +0800

dde-grand-search (5.5.14) unstable; urgency=medium

  * update version

 -- Liu zheng <liuzheng@uniontech.com>  Fri, 17 Jan 2025 21:36:12 +0800

dde-grand-search (5.5.13) unstable; urgency=medium

  * update dde-grand-search V25 5.5.13 baseline version
  * fix issue about launch app and CI build.

 -- re2zero <yangwu@uniontech.com>  Fri, 17 Jan 2025 14:45:45 +0800

dde-grand-search (5.5.12) unstable; urgency=medium

  * update dde-grand-search V25 5.5.12 baseline version
  * fix issue about launch app and CI build.

 -- re2zero <yangwu@uniontech.com>  Fri, 17 Jan 2025 14:15:36 +0800

dde-grand-search (5.5.11) unstable; urgency=medium

  * update dde-grand-search V25 5.5.11 baseline version

 -- zhangyu <zhangyub@uniontech.com>  Thu, 19 Dec 2024 21:18:40 +0800
 

dde-grand-search (5.5.10) unstable; urgency=medium

  * update varsion.
  * Workaround blocked issue

  -- re2zero <yangwu@uniontech.com>  Sat, 16 Dec 2024 04:28:55 +0800

dde-grand-search (5.5.8) unstable; urgency=medium

  * update varsion.

 -- liuyangming <liuyangming@uniontech.com>  Sat, 14 Dec 2024 13:25:53 +0800

=== debian/control ===
Source: dde-grand-search
Section: utils
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends: debhelper (>= 9),
 pkg-config,
 qt6-base-dev,
 libqt6core5compat6-dev,
 libdtk6widget-dev,
 libdtk6core-dev,
 libdtk6gui-dev,
 libdtk6core-bin,
 libdtk6declarative-dev,
 libdfm6-search-dev,
 qt6-tools-dev-tools,
 qt6-declarative-dev,
 cmake,
 dde-tray-loader-dev | dde-dock-dev,
 libglib2.0-dev,
 libffmpegthumbnailer-dev,
 libavformat-dev,
 libavcodec-dev,
 libtag1-dev,
 libicu-dev,
 libdeepin-pdfium-dev (>=1.5.1),
 libjpeg62-turbo-dev,
 liblucene++-dev,
 libboost-dev,
 libdeepin-service-framework-dev (>1.0.9),
 libdde-shell-dev
Standards-Version: 3.9.8
Homepage: http://www.deepin.org/

Package: dde-grand-search
Architecture: any
Replaces: dde-shell (<=1.99.30)
Depends: ${shlibs:Depends}, ${misc:Depends},
Recommends:
 deepin-desktop-schemas (>=5.8.0.34),
 dde-daemon (>=5.12.0.31),
 startdde (>=5.6.0.34),
 deepin-anything-server[i386 amd64]
Description: deepin desktop-environment - search module
 Search module of deepin desktop-environment

## dde-grand-search 6.0.17

=== src/preview-plugin/CMakeLists.txt ===
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")

set(FRONTEND_NAME dde-grand-search)

# 应用库目录
set(LIB_BASE_DIR "${LIB_PLATFORM_DIR}/${FRONTEND_NAME}")

# 插件目录
set(PLUGIN_BASE_DIR "${LIB_BASE_DIR}/plugins")

# 预览插件目录
set(PLUGIN_PREVIEW_DIR "${PLUGIN_BASE_DIR}/preview")
add_definitions(-DPLUGIN_PREVIEW_DIR="${PLUGIN_PREVIEW_DIR}")

# 依赖包
find_package(PkgConfig REQUIRED)
find_package(${DTK_NS} COMPONENTS
    Gui
    Widget
REQUIRED)
find_package(${QT_NS} COMPONENTS
    Core
    Gui
    Widgets
    Concurrent
REQUIRED)

set(Qt_LIBS
    ${QT_NS}::Core
    ${QT_NS}::Gui
    ${QT_NS}::Widgets
    ${QT_NS}::Concurrent
)
set(DTK_LIBS
    ${DTK_NS}::Gui
    ${DTK_NS}::Widget
)


set(QRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/resource.qrc
)

# 前端
set(FRONTEND_NAME dde-grand-search)

include_directories(${CMAKE_SOURCE_DIR}/src/grand-search/gui/exhibition/preview)

add_subdirectory(text-preview)
add_subdirectory(image-preview)
add_subdirectory(audio-preview)
add_subdirectory(pdf-preview)
add_subdirectory(video-preview)

=== tests/grand-search/CMakeLists.txt ===
# 定义需要的cmake版本
cmake_minimum_required(VERSION 3.10)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wl,--as-need -fPIE")

# 定义可执行程序名称
set(BIN_NAME test-dde-grand-search)

# 应用库目录
set(LIB_BASE_DIR "${LIB_PLATFORM_DIR}/${BIN_NAME}")

# 插件目录
set(PLUGIN_BASE_DIR "${LIB_BASE_DIR}/plugins")

# DBus接口与服务
set(3RD_PARTY_PLUGIN
    "${PROJECT_3RDPARTY_PATH}/interfaces/daemongrandsearchinterface.h"
    "${PROJECT_3RDPARTY_PATH}/interfaces/daemongrandsearchinterface.cpp"
    "${PROJECT_3RDPARTY_PATH}/services/grandsearchserviceadaptor.h"
    "${PROJECT_3RDPARTY_PATH}/services/grandsearchserviceadaptor.cpp")

# 扩展搜索插件目录
set(PLUGIN_SEARCHER_DIR "${PLUGIN_BASE_DIR}/searcher")
add_definitions(-DPLUGIN_SEARCHER_DIR="${PLUGIN_SEARCHER_DIR}")

# 预览插件目录
set(PLUGIN_PREVIEW_DIR "${PLUGIN_BASE_DIR}/preview")
add_definitions(-DPLUGIN_PREVIEW_DIR="${PLUGIN_PREVIEW_DIR}")

# 依赖包
find_package(PkgConfig REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(DtkGui REQUIRED)
find_package(DtkCMake REQUIRED)
find_package(Qt5 COMPONENTS
    Core
    Gui
    Widgets
    Concurrent
    DBus
REQUIRED)

pkg_check_modules(GIO_LIB REQUIRED
        gio-unix-2.0
        glib-2.0
)

set(Qt_LIBS
    Qt5::Core
    Qt5::Gui
    Qt5::Widgets
    Qt5::DBus
    Qt5::Concurrent
)

set(PROJECT_SRC_PATH "${PROJECT_SOURCE_PATH}/grand-search")
include_directories(${PROJECT_SRC_PATH})

#项目工程文件
FILE(GLOB_RECURSE PRO_SRC "${PROJECT_SRC_PATH}/*/*.h" "${PROJECT_SRC_PATH}/*/*.cpp")

#单元测试文件
FILE(GLOB_RECURSE UT_SRC "./*/*.cpp")

# 源文件
set(SRCS
    main.cpp
    ${GLOBAL_SRC}
    ${PRO_SRC}
    ${UT_SRC}
    ${CPP_STUB_SRC}
    ${3RD_PARTY_PLUGIN}
)

add_executable(${BIN_NAME} ${SRCS})
target_include_directories(${BIN_NAME} PUBLIC
    ${CMAKE_SOURCE_DIR}/include
    ${DtkWidget_INCLUDE_DIRS}
    ${DtkGUI_INCLUDE_DIRS}
    ${GIO_LIB_INCLUDE_DIRS}
)

target_link_libraries(${BIN_NAME} PRIVATE
    ${Qt_LIBS}
    ${DtkWidget_LIBRARIES}
    ${DtkGUI_LIBRARIES}
    ${GTEST_LIBRARIES}
    ${Qt5Test_LIBRARIES}
    ${GIO_LIB_LIBRARIES}
    -lpthread
)

=== src/preview-plugin/audio-preview/CMakeLists.txt ===
project(audio-preview)

# 定义插件名称
set(LIB_NAME audio-preview-plugin)
find_package(PkgConfig REQUIRED)
pkg_check_modules(TAGLIB REQUIRED taglib)
pkg_check_modules(AVFORMAT REQUIRED libavformat)
pkg_check_modules(ICU REQUIRED icu-i18n)

set(SRCS
    audiopreview_global.h
    audiopreviewinterface.h
    audiopreviewinterface.cpp
    audiopreviewplugin.h
    audiopreviewplugin.cpp
    audiofileinfo.h
    audiofileinfo.cpp
    audioview.h
    audioview.cpp
)

add_library(${LIB_NAME} SHARED ${SRCS})

target_include_directories(${LIB_NAME} PUBLIC
    ${TAGLIB_INCLUDE_DIRS}
    ${AVFORMAT_INCLUDE_DIRS}
)

set(Qt_CURRENT_LIBS ${Qt_LIBS})
if (QT_VERSION_MAJOR EQUAL 6)
    find_package(${QT_NS} REQUIRED COMPONENTS Core5Compat)
    set(Qt_CURRENT_LIBS ${Qt_LIBS} Qt6::Core5Compat)
endif()

target_link_libraries(${LIB_NAME} PRIVATE
    ${Qt_CURRENT_LIBS}
    ${DTK_LIBS}
    ${TAGLIB_LIBRARIES}
    ${AVFORMAT_LIBRARIES}
    ${ICU_LIBRARIES}
)

# bin
install(TARGETS ${LIB_NAME} DESTINATION ${PLUGIN_PREVIEW_DIR})
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/audio-preview-plugin.conf DESTINATION ${PLUGIN_PREVIEW_DIR})

=== src/preview-plugin/image-preview/CMakeLists.txt ===
project(image-preview)

# 定义插件名称
set(LIB_NAME image-preview-plugin)

set(SRCS
    imagepreview_global.h
    imagepreviewinterface.h
    imagepreviewinterface.cpp
    imagepreviewplugin.h
    imagepreviewplugin.cpp
    imageview.h
    imageview.cpp
)

add_library(${LIB_NAME} SHARED ${SRCS} ${QRCS})

target_link_libraries(${LIB_NAME} PRIVATE
    ${Qt_LIBS}
    ${DTK_LIBS}
    ${DtkGUI_LIBRARIES}
)

# bin
install(TARGETS ${LIB_NAME} DESTINATION ${PLUGIN_PREVIEW_DIR})

# conf
install(FILES image-preview-plugin.conf DESTINATION ${PLUGIN_PREVIEW_DIR})

=== src/preview-plugin/pdf-preview/CMakeLists.txt ===
project(pdf-preview)

# 定义插件名称
set(LIB_NAME pdf-preview-plugin)

find_package(PkgConfig REQUIRED)
pkg_check_modules(PDF REQUIRED deepin-pdfium)
pkg_check_modules(JPEG REQUIRED libjpeg)

set(SRCS
    pdfpreview_global.h
    pdfpreviewinterface.h
    pdfpreviewinterface.cpp
    pdfpreviewplugin.h
    pdfpreviewplugin.cpp
    pdfview.h
    pdfview.cpp
)

add_library(${LIB_NAME} SHARED ${SRCS} ${QRCS})

target_include_directories(${LIB_NAME} PUBLIC
    ${PDF_INCLUDE_DIRS}
)

target_link_libraries(${LIB_NAME} PRIVATE
    ${Qt_LIBS}
    ${DTK_LIBS}
    ${PDF_LIBRARIES}
    ${JPEG_LIBRARIES}
)

# bin
install(TARGETS ${LIB_NAME} DESTINATION ${PLUGIN_PREVIEW_DIR})
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/pdf-preview-plugin.conf DESTINATION ${PLUGIN_PREVIEW_DIR})

=== debian/changelog ===
dde-grand-search (6.0.17) unstable; urgency=medium

  * Deleted the `dde-grand-search_en_AU.ts` translation file as it is no longer needed.

 -- Zhang Sheng <zhangsheng@uniontech.com>  Fri, 27 Jun 2025 17:09:41 +0800

dde-grand-search (6.0.16) unstable; urgency=medium

  * fix: The search icon looks pixelated

 -- Liu Zhangjian <liuzhangjian@uniontech.com>  Thu, 26 Jun 2025 13:58:09 +0800

dde-grand-search (6.0.15) unstable; urgency=medium

  * wildcard support

 -- Zhang Sheng <zhangsheng@uniontech.com>  Mon, 23 Jun 2025 17:41:04 +0800

dde-grand-search (6.0.14) unstable; urgency=medium

  * update translations

 -- Zhang Sheng <zhangsheng@uniontech.com>  Mon, 23 Jun 2025 11:48:11 +0800

dde-grand-search (6.0.13) unstable; urgency=medium

  * improve search method handling and logging in file search components

 -- Zhang Sheng <zhangsheng@uniontech.com>  Fri, 13 Jun 2025 09:31:45 +0800

dde-grand-search (6.0.12) unstable; urgency=medium

  * fix bugs

 -- Zhang Sheng <zhangsheng@uniontech.com>  Thu, 29 May 2025 19:20:34 +0800

dde-grand-search (6.0.11) unstable; urgency=medium

  * new file-search

 -- Zhang Sheng <zhangsheng@uniontech.com>  Wed, 21 May 2025 18:11:40 +0800

dde-grand-search (6.0.10) unstable; urgency=medium

  * refactor search for filename 

 -- Zhang Sheng <zhangsheng@uniontech.com>  Tue, 20 May 2025 09:50:31 +0800

=== debian/control ===
--- 
+++ 
@@ -4,16 +4,16 @@
 Maintainer: Deepin Packages Builder <packages@deepin.com>
 Build-Depends: debhelper (>= 9),
  pkg-config,
- qt6-base-dev,
- libqt6core5compat6-dev,
- libdtk6widget-dev,
- libdtk6core-dev,
- libdtk6gui-dev,
- libdtk6core-bin,
- libdtk6declarative-dev,
- libdfm6-search-dev,
- qt6-tools-dev-tools,
- qt6-declarative-dev,
+ qt6-base-dev | qtbase5-dev,
+ qt6-5compat-dev | hello,
+ libdtk6widget-dev | libdtkwidget-dev,
+ libdtk6core-dev | libdtkcore-dev,
+ libdtk6gui-dev | libdtkgui-dev,
+ libdtk6core-bin | libdtkcore5-bin,
+ libdtk6declarative-dev | hello,
+ libdfm6-search-dev | libdfm-search-dev,
+ qt6-tools-dev-tools | qttools5-dev-tools,
+ qt6-declarative-dev | hello,
  cmake,
  dde-tray-loader-dev | dde-dock-dev,
  libglib2.0-dev,
@@ -22,12 +22,13 @@
  libavcodec-dev,
  libtag1-dev,
  libicu-dev,
- libdeepin-pdfium-dev (>=1.5.1),
+ libdeepin-pdfium-dev,
  libjpeg62-turbo-dev,
  liblucene++-dev,
  libboost-dev,
  libdeepin-service-framework-dev (>1.0.9),
- libdde-shell-dev
+ libdde-shell-dev | hello,
+ deepin-desktop-base
 Standards-Version: 3.9.8
 Homepage: http://www.deepin.org/

## dde-grand-search 6.0.20

=== debian/changelog ===
dde-grand-search (6.0.20) unstable; urgency=medium

  * chore: Update the help manual

 -- Liu Zhangjian <liuzhangjian@uniontech.com>  Thu, 10 Jul 2025 19:49:44 +0800

dde-grand-search (6.0.19) unstable; urgency=medium

  * update translations.

 -- Liuyangming <liuyangming@uniontech.com>  Thu, 03 Jul 2025 16:02:31 +0800

dde-grand-search (6.0.18) unstable; urgency=medium

  * fix bugs
  * update translations

 -- Liu Zhangjian <liuzhangjian@uniontech.com>  Tue, 01 Jul 2025 20:35:21 +0800

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

export QT_SELECT = 5

# 检测当前安装的Qt版本，优先使用Qt6，否则使用Qt5
define detect_qt_version
ifneq (,$(shell which qmake6 2>/dev/null))
    QT_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/Qt6"
else
    QT_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/Qt5"
endif
endef

# 调用检测Qt版本的命令
$(eval $(call detect_qt_version))

# hardcode this if want to force build with sepecific Qt version
# QT_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/Qt5"

%:
	dh $@ --parallel

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=Release \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DVERSION=$(DEB_VERSION_UPSTREAM) \
		-DQT_DIR=$(QT_DIR) \
		-DBUILD_OS_VERSION=$(BUILD_OS_VERSION)
